# CoreDNS version in Kubernetes

CoreDNS has been shipping with Kubernetes since CoreDNS has been an Alpha feature in Version 1.9.

This document helps map the CoreDNS version that has been shipped with Kubernetes since v1.9.
It also includes all the changes that have been made in CoreDNS from the previous release of Kubernetes to the current.


| Kubernetes Version   |      CoreDNS version      |  Changes in CoreDNS from previous release to Kubernetes |
|:--------------------:|:-------------------------:|:----------|
| v1.14 & v1.15        |  [v1.3.1](https://coredns.io/2019/01/13/coredns-1.3.1-release/)                   | TTL is also applied to negative responses (NXDOMAIN, etc). <br> <br> k8s_external a new plugin that allows external zones to point to Kubernetes in-cluster services. <br><br>kubernetes now checks if a zone transfer is allowed. Also allow a TTL of 0 to avoid caching in the cache plugin. <br><br> ***---DEPRECATIONS---*** <br><br> <ul><li>None</li></ul>|
| v1.13                |  [v1.2.6](https://coredns.io/2018/11/05/coredns-1.2.6-release/)                   | Support for using a kubeconfig file, including various auth providers (Azure not supported due to a compilation issue with that code).<br><br>`loop` plugin fixes a bug when dealing with a failing upstream.   <br><br> ***---DEPRECATIONS---*** <br><br> <ul><li>None</li></ul>|
| v1.12                |  [v1.2.2](https://coredns.io/2018/08/29/coredns-1.2.2-release/)                   | Makes the default cache size smaller.<br><br> A new plugin called loop was added. When starting up it detects resolver loops and stops the process if one is detected. <br><br> The auto plugin now works better with Kubernetes Configmaps. <br><br> ***---DEPRECATIONS---***  <br><br> <ul> <li> The etcd plugin now supports etcd version 3 (only!). It was impossible to support v2 and v3 at the same time (even as separate plugins); so we decided to drop v2 support. </li> <li>The reverse plugin has been removed, but we allow it still in the configuration.</li></ul>
| v1.11                |  [v1.1.3](https://coredns.io/2018/05/24/coredns-1.1.3-release/)                   | kubernetes has a small fix for apex queries.<br><br>kubernetes adds option to ignore services without ready endpoints.<br><br>cache fixes the critical spoof vulnerability.<br><br>A new plugin was added: reload, which watches for changes in your Corefile and then automatically will reload the process. <br><br> ***---DEPRECATIONS---*** <br><br> <ul><li>None</li></ul>
| v1.10                |  [v1.0.6](https://coredns.io/2018/02/21/coredns-1.0.6-release/)                   | A plugin called `forward` has been included in CoreDNS, this was, up until now, an external plugin.<br><br>We now support zone transfers in the kubernetes plugin.<br><br> ***Fixes a vulnerability in the underlying DNS library, CVE-2017-15133.*** <br><br>kubernetes, adds a fix for pod insecure look ups for non-IP addresses. <br><br> ***---DEPRECATIONS---*** <br><br> <ul><li>The startup and shutdown plugin are deprecated (but working and included) in this release in favor of the on plugin. If you use them, this is the moment to move to on. <br><br> </li></ul>
| v1.09                |  [v1.0.1](https://coredns.io/2017/12/11/coredns-1.0.1-release/)                   | The v1.0.1 was the first version of CoreDNS to be shipped with Kubernetes. |
